# Decorator to add some special features to a User
# TODO: This is a strong relationship to DeviseAuthentication and will to stop work if we use anything different!! (se)

# This configuration will be added by the Rails-Application
api_config = Rails.application.config.binect_config
$binect_api = Binectrest::BinectApi.new( { login: api_config[:login], password: api_config[:password], api_wsdl_url: api_config[:api_wsdl_url] } )

DeviseAuthentication::User.class_eval do
    after_create :register_to_binect

    def register_to_binect
        $binect_api.register_user(self.email, self.password)
        if $binect_api.is_error
            Rails.logger.info "Error Registering user with email: #{self.email}. Error: #{$binect_api.error}"
        else
            Rails.logger.info "Successfull register user with email: #{self.email}"
        end
    end
end
